#!/usr/bin/env python

"""
Copyright 2015 Brno University of Technology

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""

# Author: Martin Graca, xgraca00@stud.fit.vutbr.cz
#
# Description: Script compares gold standard annotations with the output of ner.py to find out whether the new version of ner.py works correctly.

import getopt
import codecs
import sys
import os
def napoveda():
	print ('napoveda programu:\nspoustejte s parametry -a SouborSAnotaci.tsv a s parametrem -o NerOutput.txt')

def main(argv): 
	AnotParam = False
	OutParam = False
	AnotationCounter = 0 # number of lines in anotation
	NerCounter = 0 # number of matched lines
	EntityCounter = 0
	matched = []
	Entity = []	
	lenmatch = []
	nermatch = []
	Absshoda = 0

	try:
		opts, args = getopt.getopt(argv,"a:o:h")
	except getopt.GetoptError:
		print 'napoveda programu'
		napoveda()
		exit()

	for opt, arg in opts:
		if (opt == '-a'):
			AnotParam = True
			AnotationFile = arg
		elif (opt == '-o'):
			OutParam = True
			NerOutFile = arg
		elif opt == '-h':
			napoveda()
			exit()

	if (AnotParam and OutParam):
		f_anotace = codecs.open(AnotationFile, 'r', encoding='utf-8')
		AnotationLines = f_anotace.readlines()
		f_NerOutput = codecs.open(NerOutFile, 'r', encoding='utf-8')
		NERLines = f_NerOutput.readlines()
		f_NerOutput = codecs.open('TravArt2Out.txt', 'r', encoding='utf-8')
		readed = f_NerOutput.read()

		for line in AnotationLines: # go through the file with anotation
			AnotationCounter = AnotationCounter + 1
			anotation = line.replace('\n', '').split('\t') # split line with anotation
			for NERLine in NERLines: # go through the file with NER output
				NerOut = NERLine.replace('\n', '').split('\t')
				if (NerOut[0] == anotation[0]): # matched start of entity
					if (NerOut[1] == anotation[1]): #matched end of entity
			#			lenmatch.append(str(line.replace('\n',''))+str(NERLine))
						if (NerOut[3] in anotation[2]): # matched name of entity
							matched.append(line)
							nermatch.append(NERLine)
							#matched.append(str(anotation[2].encode('utf8')))
							NerCounter = NerCounter + 1
		if AnotationCounter != 0:
			Absshoda = (float(float(NerCounter)/float(AnotationCounter))*100) #absolute match
			print ('absolute match anotation with NER: ' + str(Absshoda) + '%')
			if not os.path.exists("CheckNerOut"):
				os.makedirs("CheckNerOut")
			with open("CheckNerOut/"+str(NerOutFile.split('.')[0])+"_Anotation_Nonmatched.txt","w") as AnotFile:
				AnotFile.write('nonmatched entities from anotation:\n')
			#print ('non matched entities from anotation:')
			with codecs.open("CheckNerOut/"+str(NerOutFile.split('.')[0])+"_Anotation_Nonmatched.txt","a",encoding='utf-8') as AnotFile:
				for line in AnotationLines:
	#			print (matched)
					if line not in matched:
						AnotFile.write(line.replace('\n','')+'\n')
						#print (line.replace('\n','')) >> "CheckNerOut/"+str(NerOutFile.split('.')[0])+"_Anotation_Nonmatched.txt"
			with codecs.open("CheckNerOut/"+str(NerOutFile.split('.')[0])+"_Ner_Nonmatched.txt","w",encoding='utf8') as NerFile:
				NerFile.write('nonmatched entities from Ner output:\n')	
			#print ('non matched entities from Ner output:')
			with codecs.open("CheckNerOut/"+str(NerOutFile.split('.')[0])+"_Ner_Nonmatched.txt","a",encoding='utf-8') as NerFile:
                        	for line in NERLines:
                                	if line not in nermatch:
						NerFile.write(line.replace('\n','')+'\n')
                                        	#print (line.replace('\n','')) >> "CheckNerOut/"+str(NerOutFile.split('.')[0])+"_Ner_Nonmatched.txt"
			

		#	print ('len matched:')
		#	for value in lenmatch:
		#		if value not in matched:
		#			print (value.replace('\n',''))
		f_anotace.close()
		f_NerOutput.close()
	else: # bad argument, printing help
		print('bad arguments\n')
		napoveda()
		exit()

if __name__ == "__main__":
	main(sys.argv[1:])
