#!/usr/bin/env bash

cp /mnt/minerva1/nlp/projects/decipher_freebase/data/freebase.artists FREEBASE
cp /mnt/minerva1/nlp/projects/decipher_ner/ULAN/ulan_rel_13/KB.artists ULAN
cp /mnt/minerva1/nlp/projects/decipher_wikipedia/wiki_template/artists_extended WIKIPEDIA

../kb_compare.py --first=WIKIPEDIA --second=FREEBASE --rel_conf=wikipedia_freebase_rel.conf --output_conf=WF_output.conf --output=WF --id_prefix=a --other_output_conf=WF_other_output.conf --treshold=4

#no_candidates: 1454
#unique: 6699
#ambiguous_ok: 0
#ambiguous_ko: 0

../kb_compare.py --first=WF --second=ULAN --rel_conf=WF_ulan_rel.conf --output_conf=ARTISTS_output.conf --output=ARTISTS --id_prefix=a --other_output_conf=ARTISTS_other_output.conf --treshold=1

#no_candidates: 17547
#unique: 13483
#ambiguous_ok: 546
#ambiguous_ko: 600

python ../kb_fix.py ARTISTS 1 artist | python ../filter.py artist | python ../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

cut -f1,7,8 WIKIPEDIA > WIKIPEDIA.dates
cut -f12,13,19 FREEBASE | sed 's/\(.*\)\t\(.*\)\t\(.*\)/\3\t\1\t\2/g' > FREEBASE.dates
cat ARTISTS | python fix_dates.py > tmp
mv tmp ARTISTS

rm WIKIPEDIA.dates FREEBASE.dates
rm WF

# Dataset: ---apr---
cd apr		#vramci integracie apr sa vytvara stlpec OTHER URL
sort -u /mnt/minerva1/nlp/datasets/art/apr/apr.tsv > ./APR
mv ../ARTISTS ./

../../kb_compare.py --first=APR --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm APR
rm ARTISTS
cd ..

# Dataset: ---artbiogs---
cd artbiogs
sort -u /mnt/minerva1/nlp/datasets/art/artbiogs/artbiogs.tsv > ./ARTBIOGS
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=ARTBIOGS --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm ARTBIOGS
rm ARTISTS
cd ..

# Dataset: ---artists2artists---
cd artists2artists
sort -u /mnt/minerva1/nlp/datasets/art/artists2artists/artists2artists.tsv > ./A2A
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=A2A --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm A2A
rm ARTISTS
cd ..

# Dataset: ---artrepublic---
cd artrepublic
sort -u /mnt/minerva1/nlp/datasets/art/artrepublic/artrepublic.tsv > ./ARTREPUBLIC
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=ARTREPUBLIC --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm ARTREPUBLIC
rm ARTISTS
cd ..

# Dataset: ---bbc---
cd bbc
sort -u /mnt/minerva1/nlp/datasets/art/bbc/bbc.tsv > ./BBC
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=BBC --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm BBC
rm ARTISTS
cd ..

# Dataset: ---biography---
cd biography
sort -u /mnt/minerva1/nlp/datasets/art/biography/biography.tsv > ./BIOGRAPHY
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=BIOGRAPHY --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm BIOGRAPHY
rm ARTISTS
cd ..

# Dataset: ---council---
cd council
sort -u /mnt/minerva1/nlp/datasets/art/council/council.tsv > ./COUNCIL
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=COUNCIL --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm COUNCIL
rm ARTISTS
cd ..

# Dataset: ---davisart---
cd davisart
sort -u /mnt/minerva1/nlp/datasets/art/davisart/davisart.tsv > ./DAVISART
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=DAVISART --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm DAVISART
rm ARTISTS
cd ..

# Dataset: ---distinguishedwomen---
cd distinguishedwomen
sort -u /mnt/minerva1/nlp/datasets/art/distinguishedwomen/distinguishedwomen.tsv > ./DISTINGUISHEDWOMEN
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=DISTINGUISHEDWOMEN --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm DISTINGUISHEDWOMEN
rm ARTISTS
cd ..

# Dataset: ---englandgallery---
cd englandgallery
sort -u /mnt/minerva1/nlp/datasets/art/englandgallery/englandgallery.tsv > ./ENGLANDGALLERY
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=ENGLANDGALLERY --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm ENGLANDGALLERY
rm ARTISTS
cd ..

# Dataset: ---infoplease---
cd infoplease
sort -u /mnt/minerva1/nlp/datasets/art/infoplease/infoplease.tsv > ./INFOPLEASE
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=INFOPLEASE --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm INFOPLEASE
rm ARTISTS
cd ..

# Dataset: ---nationalgallery---
cd nationalgallery
sort -u /mnt/minerva1/nlp/datasets/art/nationalgallery/nationalgallery.tsv > ./NATIONALGALLERY
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=NATIONALGALLERY --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm NATIONALGALLERY
rm ARTISTS
cd ..

# Dataset: ---nmwa---
cd nmwa
sort -u /mnt/minerva1/nlp/datasets/art/nmwa/nmwa.tsv > ./NMWA
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=NMWA --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm NMWA
rm ARTISTS
cd ..

# Dataset: ---open---
cd open
sort -u /mnt/minerva1/nlp/datasets/art/open/open.tsv > ./OPEN
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=OPEN --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm OPEN
rm ARTISTS
cd ..

# Dataset: ---rkd---
cd rkd
sort -u /mnt/minerva1/nlp/datasets/art/rkd/rkd.tsv > ./RKD
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=RKD --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm RKD
rm ARTISTS
cd ..

# Dataset: ---the-artists---
cd the-artists
sort -u /mnt/minerva1/nlp/datasets/art/the-artists/the-artists.tsv > ./THE
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=THE --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm THE
rm ARTISTS
cd ..

# Dataset: ---wikipaint---
cd wikipaint
sort -u /mnt/minerva1/nlp/datasets/art/wikipaint/final_data/wikipaint_artist.tsv > ./WIKIPAINT
mv ../ARTISTS ./
cat ARTISTS | python ../../remove_duplicate_terms.py artist > tmp
mv tmp ARTISTS

../../kb_compare.py --first=WIKIPAINT --second=ARTISTS --rel_conf=OUT_rel.conf --output_conf=OUT_output.conf --output=OUT --id_prefix=a --other_output_conf=OUT_other_output.conf --treshold=1

mv ./OUT ../ARTISTS
rm WIKIPAINT
rm ARTISTS
cd ..
