#!/bin/sh

TIME=`date +%s`

BACKUP_DIRECTORY=/mnt/data-in/knot/iotrusina/KB_data_backups/$TIME

ARTIST_DIRECTORY=$BACKUP_DIRECTORY/artists
ARTWORK_DIRECTORY=$BACKUP_DIRECTORY/artworks
LOCATION_DIRECTORY=$BACKUP_DIRECTORY/locations
MUSEUM_DIRECTORY=$BACKUP_DIRECTORY/museums
PERSON_DIRECTORY=$BACKUP_DIRECTORY/persons
MYTHOLOGY_DIRECTORY=$BACKUP_DIRECTORY/mythology
ARTIST_FAMILIES_DIRECTORY=$BACKUP_DIRECTORY/artist_families
ARTIST_GROUP_OR_COLLECTIVE_DIRECTORY=$BACKUP_DIRECTORY/artist_group_or_collective

PROJECTS_DIRECTORY=/mnt/minerva1/nlp/projects

ULAN_DIRECTORY=$PROJECTS_DIRECTORY/decipher_ner/ULAN/ulan_rel_13
FREEBASE_DIRECTORY=$PROJECTS_DIRECTORY/decipher_freebase/data
GEONAMES_DIRECTORY=$PROJECTS_DIRECTORY/decipher_geonames
DBPEDIA_DIRECTORY=$PROJECTS_DIRECTORY/decipher_dbpedia/extraction_results/v39
WIKIPEDIA_DIRECTORY=$PROJECTS_DIRECTORY/decipher_wikipedia
NER_DIRECTORY=$PROJECTS_DIRECTORY/decipher_ner
DATASETS_DIRECTORY=/mnt/minerva1/nlp/datasets/art

echo "Creating directories in "$BACKUP_DIRECTORY
mkdir $BACKUP_DIRECTORY
mkdir $ARTIST_DIRECTORY
mkdir $ARTWORK_DIRECTORY
mkdir $LOCATION_DIRECTORY
mkdir $MUSEUM_DIRECTORY
mkdir $PERSON_DIRECTORY
mkdir $MYTHOLOGY_DIRECTORY
mkdir $ARTIST_FAMILIES_DIRECTORY
mkdir $ARTIST_GROUP_OR_COLLECTIVE_DIRECTORY

echo "Copying files to "$ARTIST_DIRECTORY
cp $FREEBASE_DIRECTORY/freebase.artists $ARTIST_DIRECTORY/FREEBASE
cp $ULAN_DIRECTORY/KB.artists $ARTIST_DIRECTORY/ULAN
cp $WIKIPEDIA_DIRECTORY/wiki_template/artists_extended $ARTIST_DIRECTORY/WIKIPEDIA
cp $DATASETS_DIRECTORY/artbiogs/artbiogs.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/bbc/bbc.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/council/council.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/distinguishedwomen/distinguishedwomen.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/artists2artists/artists2artists.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/the-artists/the-artists.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/nationalgallery/nationalgallery.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/biography/biography.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/wikipaint/final_data/wikipaint_artist.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/davisart/davisart.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/apr/apr.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/rkd/rkd.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/open/open.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/artrepublic/artrepublic.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/englandgallery/englandgallery.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/nmwa/nmwa.tsv $ARTIST_DIRECTORY/DATASETS
cp $DATASETS_DIRECTORY/infoplease/infoplease.tsv $ARTIST_DIRECTORY/DATASETS

echo "Copying files to "$ARTWORK_DIRECTORY
cp $DBPEDIA_DIRECTORY/v39_artwork_finall.tsv $ARTWORK_DIRECTORY/DBPEDIA
cp $FREEBASE_DIRECTORY/freebase.artworks $ARTWORK_DIRECTORY/FREEBASE

echo "Copying files to "$LOCATION_DIRECTORY
cp $DBPEDIA_DIRECTORY/v39_location_finall.tsv $LOCATION_DIRECTORY/DBPEDIA
cp $FREEBASE_DIRECTORY/freebase.locations $LOCATION_DIRECTORY/FREEBASE
cp $GEONAMES_DIRECTORY/geonames.locations $LOCATION_DIRECTORY/GEONAMES

echo "Copying files to "$MUSEUM_DIRECTORY
cp $DBPEDIA_DIRECTORY/v39_museum_finall.tsv $MUSEUM_DIRECTORY/DBPEDIA
cp $FREEBASE_DIRECTORY/freebase.museums $MUSEUM_DIRECTORY/FREEBASE
cp $ULAN_DIRECTORY/KB.corporations $MUSEUM_DIRECTORY/ULAN
cp $GEONAMES_DIRECTORY/geonames.museums $LOCATION_DIRECTORY/GEONAMES

echo "Copying files to "$PERSON_DIRECTORY
cp $FREEBASE_DIRECTORY/freebase.persons $PERSON_DIRECTORY/FREEBASE
cp $WIKIPEDIA_DIRECTORY/Ludia_Wikipedia/outputs/categories_death_birth_data.csv $PERSON_DIRECTORY/WIKIPEDIA

echo "Copying files to "$MYTHOLOGY_DIRECTORY
cp $PROJECTS_DIRECTORY/extrakce_z_wikipedie/xgraca00/MythologyKB.txt $MYTHOLOGY_DIRECTORY/WIKIPEDIA

echo "Copying files to "$ARTIST_FAMILIES_DIRECTORY
cp $PROJECTS_DIRECTORY/extrakce_z_wikipedie/xdosta40/final/finalFamilies.xml $ARTIST_FAMILIES_DIRECTORY/ARTIST_FAMILIES

echo "Copying files to "$ARTIST_GROUP_OR_COLLECTIVE_DIRECTORY
cp $PROJECTS_DIRECTORY/extrakce_z_wikipedie/xdosta40/final/finalGroupsAndCollectives.xml $ARTIST_GROUP_OR_COLLECTIVE_DIRECTORY/ARTIST_GROUP_OR_COLLECTIVE

