import sys

def fix_general(l):

    fields = l.split("\t")

    name = fields[2].strip()
    aliases = [a.strip() for a in fields[3].split("|") if a.strip() != ""]

    if name == "":
        if aliases:
            name = aliases[0].strip()
            fields[2] = name
        else:
            return

    result = [a.strip() for a in aliases if a not in [name, ""]]
    fields[3] = "|".join(result)

    print "\t".join(fields)

def fix_artists(l):

    fields = l.split("\t")

    display_name = fields[2].strip()
    preferred_name = fields[3].strip()
    aliases = [a.strip() for a in fields[4].split("|") if a.strip() != ""]

    # fixes multiple values in display term
    if "|" in display_name:
        names = display_name.split("|")
        aliases.extend(names)
        display_name = names[0]
        fields[2] = display_name

    # fixes multiple values in preferred term
    if "|" in preferred_name:
        names = preferred_name.split("|")
        aliases.extend(names)
        preferred_name = names[-1]
        fields[3] = preferred_name

    if display_name == "":
        if aliases:
            display_name = aliases[0].strip()
            fields[2] = display_name
        else:
            return

    result = [a.strip() for a in aliases if a not in [display_name, preferred_name, ""]]
    fields[4] = "|".join(result)

    preferred_role = fields[5].strip()
    roles = fields[6].split("|")

    if preferred_role == "" and len(roles) > 0:
        preferred_role = roles[0].strip()
        fields[5] = preferred_role

    result = [r.strip() for r in roles if r not in [preferred_role, ""]]
    fields[6] = "|".join(result)

    preferred_nationality = fields[7]
    nationalities = fields[8].split("|")

    if preferred_nationality == "" and len(nationalities) > 0:
        preferred_nationality = nationalities[0]
        fields[7] = preferred_nationality

    result = [n.strip() for n in nationalities if n not in [preferred_nationality, ""]]
    fields[8] = "|".join(result)

    print "\t".join(fields)

if __name__ == "__main__":

    entity_type = sys.argv[1]

    for l in sys.stdin:
        l = l[:-1]
        if entity_type == "artist":
            fix_artists(l)
        else:
            fix_general(l)
