#!/bin/sh

export LC_ALL="C"

# $1 = KBstatsMetrics.all (knowledge base)

#======================================================================
# vytvorenie zoznamu klucov entit v KB a vyhodenie fragmentov zo zoznamu
python KB2namelist.py -a < "$1" | tr -s ' ' | grep -v -e "[^;]N" > intext_auto
cat intext_auto | grep "^person:" | sed 's/^person:\t//' > p_intext
cat intext_auto | grep "^artist:" | sed 's/^artist:\t//' > a_intext
cat intext_auto | grep "^location:" | sed 's/^location:\t//' > l_intext
cat intext_auto | grep "^artwork:" | sed 's/^artwork:\t//' > w_intext
cat intext_auto | grep "^museum:" | sed 's/^museum:\t//' > c_intext
cat intext_auto | grep "^event:" | sed 's/^event:\t//' > e_intext
cat intext_auto | grep "^visual_art_form:" | sed 's/^visual_art_form:\t//' > f_intext
cat intext_auto | grep "^visual_art_medium:" | sed 's/^visual_art_medium:\t//' > d_intext
cat intext_auto | grep "^art_period_movement:" | sed 's/^art_period_movement:\t//' > m_intext
cat intext_auto | grep "^visual_art_genre:" | sed 's/^visual_art_genre:\t//' > g_intext
cat intext_auto | grep "^nationality:" | sed 's/^nationality:\t//' > n_intext
cat intext_auto | grep "^mythology:" | sed 's/^mythology:\t//' > y_intext
cat intext_auto | grep "^family:" | sed 's/^family:\t//' > i_intext
cat intext_auto | grep "^group:" | sed 's/^group:\t//' > r_intext
cut -f2- intext_auto > x_intext

#======================================================================
# parsovanie confidence hodnot do samostatneho suboru + stop list
cat "$1" | awk '{print $(NF)}' > KB_confidence
cp stop_list stop_list.all.sorted

#======================================================================
# skript, ktery slouci duplicty (cisla radku do jednoho)
python uniq_namelist.py -s "KB_confidence" < p_intext | tr '\t' '|' > p_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < a_intext | tr '\t' '|' > a_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < l_intext | tr '\t' '|' > l_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < w_intext | tr '\t' '|' > w_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < c_intext | tr '\t' '|' > c_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < e_intext | tr '\t' '|' > e_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < f_intext | tr '\t' '|' > f_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < d_intext | tr '\t' '|' > d_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < m_intext | tr '\t' '|' > m_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < g_intext | tr '\t' '|' > g_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < n_intext | tr '\t' '|' > n_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < x_intext | tr '\t' '|' > x_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < y_intext | tr '\t' '|' > y_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < i_intext | tr '\t' '|' > i_namelist.UTF-8
python uniq_namelist.py -s "KB_confidence" < r_intext | tr '\t' '|' > r_namelist.UTF-8

#======================================================================
# prevod UTF8 na ASCII
./utf2symbols < p_namelist.UTF-8 | sort -u > p_namelist.ASCII
./utf2symbols < a_namelist.UTF-8 | sort -u > a_namelist.ASCII
./utf2symbols < l_namelist.UTF-8 | sort -u > l_namelist.ASCII
./utf2symbols < w_namelist.UTF-8 | sort -u > w_namelist.ASCII
./utf2symbols < c_namelist.UTF-8 | sort -u > c_namelist.ASCII
./utf2symbols < e_namelist.UTF-8 | sort -u > e_namelist.ASCII
./utf2symbols < f_namelist.UTF-8 | sort -u > f_namelist.ASCII
./utf2symbols < d_namelist.UTF-8 | sort -u > d_namelist.ASCII
./utf2symbols < m_namelist.UTF-8 | sort -u > m_namelist.ASCII
./utf2symbols < g_namelist.UTF-8 | sort -u > g_namelist.ASCII
./utf2symbols < n_namelist.UTF-8 | sort -u > n_namelist.ASCII
./utf2symbols < x_namelist.UTF-8 | sort -u > x_namelist.ASCII
./utf2symbols < y_namelist.UTF-8 | sort -u > y_namelist.ASCII
./utf2symbols < i_namelist.UTF-8 | sort -u > i_namelist.ASCII
./utf2symbols < r_namelist.UTF-8 | sort -u > r_namelist.ASCII

#=====================================================================
# prevod cisel z formatu string do binarnej podoby
./str2bin < p_namelist.ASCII > p_namelist.ASCII.bin
./str2bin < a_namelist.ASCII > a_namelist.ASCII.bin
./str2bin < l_namelist.ASCII > l_namelist.ASCII.bin
./str2bin < w_namelist.ASCII > w_namelist.ASCII.bin
./str2bin < c_namelist.ASCII > c_namelist.ASCII.bin
./str2bin < e_namelist.ASCII > e_namelist.ASCII.bin
./str2bin < f_namelist.ASCII > f_namelist.ASCII.bin
./str2bin < d_namelist.ASCII > d_namelist.ASCII.bin
./str2bin < m_namelist.ASCII > m_namelist.ASCII.bin
./str2bin < g_namelist.ASCII > g_namelist.ASCII.bin
./str2bin < n_namelist.ASCII > n_namelist.ASCII.bin
./str2bin < x_namelist.ASCII > x_namelist.ASCII.bin
./str2bin < y_namelist.ASCII > y_namelist.ASCII.bin
./str2bin < i_namelist.ASCII > i_namelist.ASCII.bin
./str2bin < r_namelist.ASCII > r_namelist.ASCII.bin

#======================================================================
# vytvoreni konecneho automatu
fsa/fsa_build < p_namelist.ASCII.bin > ../p_automata.fsa
fsa/fsa_build < a_namelist.ASCII.bin > ../a_automata.fsa
fsa/fsa_build < l_namelist.ASCII.bin > ../l_automata.fsa
fsa/fsa_build < w_namelist.ASCII.bin > ../w_automata.fsa
fsa/fsa_build < c_namelist.ASCII.bin > ../c_automata.fsa
fsa/fsa_build < e_namelist.ASCII.bin > ../e_automata.fsa
fsa/fsa_build < f_namelist.ASCII.bin > ../f_automata.fsa
fsa/fsa_build < d_namelist.ASCII.bin > ../d_automata.fsa
fsa/fsa_build < m_namelist.ASCII.bin > ../m_automata.fsa
fsa/fsa_build < g_namelist.ASCII.bin > ../g_automata.fsa
fsa/fsa_build < n_namelist.ASCII.bin > ../n_automata.fsa
fsa/fsa_build < x_namelist.ASCII.bin > ../x_automata.fsa
fsa/fsa_build < y_namelist.ASCII.bin > ../y_automata.fsa
fsa/fsa_build < i_namelist.ASCII.bin > ../i_automata.fsa
fsa/fsa_build < r_namelist.ASCII.bin > ../r_automata.fsa

#=====================================================================
# smazani mezivysledku
rm -f intext_auto *_intext
rm -f *_namelist.UTF-8
rm -f *_namelist.ASCII
rm -f *_namelist.ASCII.bin
rm -f KB_confidence
