#/bin/sh

# default values
UPLOAD=false
IMAGES=false

#=====================================================================
# nastavovani parametru prikazove radky

usage()
{
    echo "Usage: start.sh [-u]"
    echo ""
    echo "\t-h --help"
    echo "\t-u --upload"
    echo ""
}

while [ "$1" != "" ]; do
    PARAM=`echo $1 | awk -F= '{print $1}'`
    VALUE=`echo $1 | awk -F= '{print $2}'`
    case $PARAM in
        -h | --help)
            usage
            exit
            ;;
        -u | --upload)
            UPLOAD=true
            ;;
        -i | --images)
            IMAGES=true
            ;;
        *)
            echo "ERROR: unknown parameter \"$PARAM\""
            usage
            exit 1
            ;;
    esac
    shift
done

#=====================================================================
# creating partial files for KB

echo "creating partial files for KB"
cd KnowBase
./start.sh 
./copyKB.sh
./deleteKB.sh
cd ..

#=====================================================================
# creating KB

echo "creating KB"
if $IMAGES ; then
  ./prepare_data -i
else
  ./prepare_data
fi

rm -f ner_namedict.pkl
rm -f ../KB-HEAD.all
rm -f ../KB-HEAD.all.bin
make ../KB-HEAD.all

#=====================================================================
# creating automaton for NER

echo "creating automaton for NER"
cd figa/make_automat
./create_fsa.sh --knowledge-base=../../KBstatsMetrics.all

#=====================================================================
# creating automaton for autocomplete

echo "creating automaton for autocomplete"
./create_fsa_autocomplete.sh ../../KBstatsMetrics.all 

#=====================================================================
# creating automaton for NER lowercase

echo "creating automaton for NER lowercase"
./create_fsa.sh -l --knowledge-base=../../KBstatsMetrics.all

#=====================================================================
# creating automaton for NER spellchecking

echo "creating automaton for NER spellchecking"
./create_fsa.sh -s --knowledge-base=../../KBstatsMetrics.all

#=====================================================================
# creating automaton for URIs

echo "creating automaton for URIs"
./create_fsa.sh -u --knowledge-base=../../KBstatsMetrics.all
cd ../..

#=====================================================================
# uploading KB

if $UPLOAD ; then
  echo "uploading KB"
  ./uploadKB.sh
fi
