#!/usr/bin/python
# -*- coding: utf-8 -*-

#xmicha44

import os, sys, getopt, re, time
import tarfile
import shutil

suffix = '_files.txt'

def getFileListFromArchive(tarFile):
	list = []
	
	with tarfile.open(tarFile, "r") as file:
		members = file.getmembers()
		
		for item in members:
			if item.isreg():
				list.append(item.name)
				
	return list


def createDictFromFile(pathToFile, countryCode, dict):
	
	with open(pathToFile, "r") as file:
		
		#extract file name from path
		pos = pathToFile.rfind('/')
		if pos >= 0:
			archiveName = pathToFile[pos+1:]
		else:
			archiveName = pathToFile
			
		#remove suffix
		archiveName = archiveName[:-len(suffix)]
		
		lines = file.readlines()
		for line in lines:
					
			#split to file path and file name
			#key = tuple of country code, file name
			#value = archive name, file path
				
			pos = line.rfind('/')
			if pos >= 0:
				#/foo/foo/enfoo.jpg
				itemName = line[pos+1:]
			else:
				#enfoo.jpg	
				itemName = line
								
			key = (countryCode, itemName.strip())
			value = {}
			#value['tar'] = compressArchiveName(archiveName)
			value['tar'] = archiveName
			value['imagepath'] = line[:pos+1]
				
			dict[key] = value
			dict[itemName.strip()] = value

def saveFileList(pathToFile, pathToSave):
	list = getFileListFromArchive(pathToFile)
	
	with open(pathToSave+suffix,'w') as file:
		for item in list:
			file.write(item)
			file.write('\n')
	
	#print pathToFile + '-> ' + pathToSave
	#print '%s \t\t\t\t %d' % (pathToFile, len(list))
	
							

def createDictionary(pathToLists):
	dict = {}
	for dirpath, dirnames, filenames in os.walk(pathToLists):
		for filename in [f for f in filenames if f.endswith(suffix)]:
			
			pathToActualFile = os.path.join(dirpath, filename)
			countryCode = filename[:2]

			createDictFromFile(pathToActualFile,countryCode, dict)		
			#dict.update(actualDir)	
			#print '%s \t\t\t\t %d' % (filename, len(actualDir.keys()))
			
	
	return dict
	
def createFileLists(pathToArchivesDir, pathToLists):
	
	for dirpath, dirnames, filenames in os.walk(pathToArchivesDir):
		for filename in [f for f in filenames if f.endswith(".tar")]:
			
			pathToActualTar = os.path.join(dirpath, filename)
			pathToSave = os.path.join(pathToLists, filename)	
			
			saveFileList(pathToActualTar, pathToSave)
			
			#print '%s \t\t\t\t %d' % (filename, len(actualDir.keys()))

searches = list()
extracts = list()
def extractFromArchive(pathToArchivesDir,archiveName, fileToExtract, pathToSave):
	global searches
	global extracts
	start = time.time()
	for dirpath, dirnames, filenames in os.walk(pathToArchivesDir):
		for filename in [f for f in filenames if f.endswith(".tar")]:
			if filename == archiveName:
				searches.append(time.time() - start)
				start = time.time()	
				pathToActualTar = os.path.join(dirpath, filename)
				with tarfile.open(pathToActualTar, 'r') as file:
					try:
						print "Path To Save : " + str(pathToSave)
						print "File to Extract: " + str(fileToExtract) 
						#file.extractall(pathToSave, fileToExtract)
						target = fileToExtract.pop()
						image = file.extractfile(target)
						extracts.append(time.time() - start)
						dest = pathToSave+str(target.name).strip().split("wikipedia/", 1)[1]
						if not os.path.isfile(dest):
							try:
								os.makedirs(re.sub('(.*)\/[^/]*', '\\1', dest), 0o777)
							except OSError as exc:
								if os.path.isdir(re.sub('(.*)\/[^/]*', '\\1', dest)):
									pass
								else: raise
						with open(dest, 'wb') as out_file:
							shutil.copyfileobj(image, out_file)
						print "EXTRACTED!!!"
					except Exception,e:
						print e
						return False
					
	return True

def getTarFile(pathToArchivesDir,archiveName):
	global searches
	global extracts
	start = time.time()
	print "OS.WALK: " + pathToArchivesDir
	for dirpath, dirnames, filenames in os.walk(pathToArchivesDir):
		print "Filenames: " + str(filenames)
	
		for filename in [f for f in filenames if f.endswith(".tar")]:
			print "FILENAME: " + filename
			print "achiveName: " + archiveName 
			if filename == archiveName:
				pathToActualTar = os.path.join(dirpath, filename)
				print "RETURNING: " + str(pathToActualTar)
				return tarfile.open(pathToActualTar, 'r')
def search(line, dict):
	#split to countryCode and image
	countryCode = line.split(":")[0]
	imageName = line.split(":")[1]
	
	result = dict.get((countryCode, imageName))
	if not result:
		print "Searching " + line.split(":")[1] + " from global"
		result = dict.get(line.split(":")[1])
		if not result:
			print "NOT FOUND " + imageName	
	return result
def searchMode(dict, pathToArchivesDir, pathToExtract):
	archToFile = {} 
	while True:
		try:
			line = raw_input()
			if line == 'q':
				break
			result = search(line, dict)
			if result:
				#print 'result: %s %s' % (result['tar'], result['imagepath'])
				
				fileName = line.split(":")[1]
				if not result['tar'] in archToFile:
					archToFile[result['tar']] = list()
				fileToExtract = os.path.join(result['imagepath'],fileName)
				archToFile[result['tar']].append(fileToExtract)
			else:
				print 'unknown ' +str(line) 
		except EOFError:
			break
	for tarFile in archToFile:
		#print "FROM: " + tarFile + "\n"
		#print "PATH: " + pathToArchivesDir + "\n"
		#print archToFile[tarFile]
		tf =  getTarFile(pathToArchivesDir, tarFile)
		print "TF: " + str(tf)
		infos = tf.getmembers()
		imginfos = list()
		for info in infos:
			if info.name in archToFile[tarFile]:
				imginfos.append(info)
		extractFromArchive(pathToArchivesDir, tarFile, imginfos, pathToExtract)
help = 'Script to search and extract files from tar archives.\n'
help += 'usage:\n'
help += './archfind.py -c --apath=<path-to-archives> --lpath=<path-to-list> : create mode. create list of files for each tar archive and save it to --lpath direcotry.\n'
help += './archfind.py -s --apath=<path-to-archives> --lpath=<path-to-list> --epath=<path-to-extract> : search and extract mode\n'
help += 'query format from stdin: CC:image\n'
help += '    CC = country code\n'
help += '    image = image name\n'
help += 'quit search mode: enter q or EOF\n'

def main(argv):
	'''
	if len(sys.argv) > 1:
		pathToArchives = sys.argv[1]
	else:
		pathToArchives = './test-data'
	'''
		
	try:
		opts, args = getopt.getopt(argv,"csh",['apath=','lpath=', 'epath='])
	except getopt.GetoptError:
		print help
		#print 'test.py -i <inputfile> -o <outputfile>'
		sys.exit(2)
	
	cflag = sflag = aflag = lflag =  eflag = 0
	pathToArchives = ''
	pathToLists = '' 
	pathToExtract = '' 
	
	
	for opt, arg in opts:
		if opt == '-h':
			print help
			sys.exit(0)
		elif opt == '-c':
			cflag = 1
		elif opt == '-s':
			sflag = 1
		elif opt == '--apath':
			aflag = 1
			pathToArchives = arg
		elif opt == '--lpath':
			lflag = 1
			pathToLists = arg
		elif opt == '--epath':
			eflag = 1
			pathToExtract = arg
			
				
	if(cflag and aflag and lflag):
		createFileLists(pathToArchives,pathToLists)			
	elif(sflag and aflag and lflag and eflag):
		
		dict = createDictionary(pathToLists)
		#print 'dictionary create done'
		
		print 'Welcome to search mode. Enter q or EOF to quit.'
		
		searchMode(dict, pathToArchives, pathToExtract);
		
		'''
		for item in dict.items():
			print "(%s, %s) : (%s, %s)" % (item[0][0], item[0][1], item[1]['tar'], item[1]['imagepath'])
			pass
		'''
	else:	
		print help;
		sys.exit(0)
				
	
if __name__ == "__main__":
	main(sys.argv[1:])
	print searches
	print extracts



