# -*- coding: utf-8 -*-
import os
import os.path
import sys
import urllib.request
import shutil
import re
from iritouri import iri2uri

SAVE_FOLDER = "/mnt/athena3/kb/images/wikimedia"
KB_ALL = "KB.all"

with open(KB_ALL, 'r') as file:
	kb_all = file.read()

for line in sys.stdin:
	url = line.strip()
	dest = SAVE_FOLDER+"/"+line.strip().split("wikipedia/", 1)[1]
	if not os.path.isfile(dest):
		newUrl = re.sub("/commons/", "/en/", url)
		newDest = re.sub("/commons/", "/en/", dest)
		if newUrl == url:
			newUrl = re.sub("/en/", "/commons/", url)
			newDest = re.sub("/en/", "/commons/", dest)
		if newUrl != url:
			try:
				os.makedirs(re.sub('(.*)\/[^/]*', '\\1', newDest), 0o777, True)
			except OSError as exc:
				if os.path.isdir(re.sub('(.*)\/[^/]*', '\\1', newDest)):
					pass
				else: raise
			try:
				with urllib.request.urlopen(iri2uri(newUrl)) as response, open(newDest, 'wb') as out_file:
					shutil.copyfileobj(response, out_file)
				kb_all = kb_all.replace("wikimedia/"+url.split("/wikipedia/", 1)[1], "wikimedia/"+newUrl.split("/wikipedia/", 1)[1])
			except urllib.error.HTTPError as exc:
				kb_all = kb_all.replace("wikimedia/"+url.split("/wikipedia/", 1)[1]+"|", "")
				kb_all = kb_all.replace("wikimedia/"+url.split("/wikipedia/", 1)[1], "")
				pass

with open(KB_ALL, 'w') as file:
	file.write(kb_all)